/*************************************************
 **																							**
 **		dbase.h   		                            **
 **                                             **
 **					SoftC dbase3 toolkit header					**
 **																							**
 **					Copyright (C) 1988, 1989 by 				**
 **								Kim Schumann									**
 **								16820 3rd St NE								**
 **								Ham Lake, MN 55304						**
 **								(612) 434-6968								**
 **																							**
 **							All rights reserved.						**
 **						Proprietary information.					**
 **		Use requires license from Kim Schumann,		**
 **					or an authorized distributor.				**
 *************************************************/




/**********
 *
 *	defines
 *
 **********/




/* scrput definitions */
#define SC_UPDATE 1									/* update current record */
#define SC_ADD 2										/* add new record */

/* scrcopy & scrclear definitions */
#define SC_INPUT 1									/* input buffer */
#define SC_OUTPUT 2									/* output buffer */

/* sckfind definitions */
#define SC_FIRST 1									/* find first key */
#define SC_EXACT 2									/* find exact key (uses record number) */




/**********
 *
 *		Type Definitions
 *
 **********/




typedef struct {	/* database field description */
	signed char name[11];	/* field name */
	signed char type;				/* field type
													 * 'c' or 'C' - character
													 * 'd' or 'D' - date
													 * 'l' or 'L' - logical
													 *							't' or 'T' - true
													 *							'f' or 'F' - false
													 *							'y' or 'Y' - yes
													 *							'n' or 'N' - no
													 *							'?'				 - uninitialized
													 * 'n' or 'N' - numeric */
	unsigned char len;			/* field width */
	unsigned char decpl;		/* decimal count */
} SC_FIELD;




/**********
 *
 *			.DBF File Manipulator Prototypes
 *
 **********/




signed short int scdclose( signed char );
signed short int scdcreate( signed char *, signed char, SC_FIELD * );
signed short int scdinfo( signed char, signed char * );
signed short int scdopen( signed char *, signed char * );
signed short int scdsize( signed char, signed long int * );




/**********
 *
 *			.DBF Field Manipulator Prototypes
 *
 **********/




signed short int scdfget( signed char, signed char, void * );
signed short int scdfgets( signed char, signed char, char * );
signed short int scdfinfo( signed char, signed char *, SC_FIELD * );
signed short int scdfnam2no( signed char, signed char *, signed char * );
signed short int scdfput( signed char, signed char, void * );
signed short int scdfputs( signed char, signed char, char * );




/**********
 *
 *			.NDX File Manipulators Prototypes
 *
 **********/




signed short int sciclose( signed char );
signed short int scicreate( signed char *, signed char, signed char *, signed char );
signed short int sciexpr( signed char, signed char * );
signed short int sciinfo( signed char, signed char *, signed char *, signed char *, signed short int * );
signed short int sciopen( signed char *, signed char * );




/**********
 *
 *			.NDX Key Manipulator Prototypes
 *
 **********/




signed short int scikadd( signed char, signed char *, signed long int );
signed short int scikcur( signed char, signed char *, signed long int * );
signed short int scikdel( signed char, signed char *, signed long int );
signed short int scikfirst( signed char, signed char *, signed long int * );
signed short int scikfind( signed char, signed char, signed char *, signed long int * );
signed short int sciklast( signed char, signed char *, signed long int * );
signed short int scikmake( signed char, signed char, void ** );
signed short int sciknext( signed char, signed char *, signed long int * );
signed short int scikprev( signed char, signed char *, signed long int * );




/**********
 *
 *			.NDX Page Manipulator Prototypes
 *
 **********/




signed short int scipinfo( signed char, signed char *);
signed short int scipnum( signed char, signed char * );




/**********
 *
 *			.DBF Record Manipulator Prototypes
 *
 **********/




signed short int scdrclear( signed char, signed short );
signed short int scdrcopy( signed char, signed short );
signed short int scdrdel( signed char, signed long int );
signed short int scdrget( signed char, signed long int );
signed short int scdrinfo( signed char, signed short *, signed char *, void **, void ** );
signed short int scdrput( signed char, signed short, signed long int * );
signed short int scdrundel( signed char, signed long int );




