/*************************************************
 **																							**
 **		SoftC.h                                   **
 **                                             **
 **					SoftC common toolkit header					**
 **																							**
 **					Copyright (C) 1988, 1989 by 				**
 **								Kim Schumann									**
 **								16820 3rd St NE								**
 **								Ham Lake, MN 55304						**
 **								(612) 434-6968								**
 **																							**
 **							All rights reserved.						**
 **						Proprietary information.					**
 **		Use requires license from Kim Schumann,		**
 **					or an authorized distributor.				**
 *************************************************/



/**********
 *
 *	Function Return Codes
 *
 **********/




#define SC_NOFIND			4			/* WARNING - could not find key in index file */
#define SC_END				3			/* WARNING - no more keys */
#define SC_EMPTY			2			/* WARNING - file is empty */
#define SC_DELREC			1			/* WARNING - record read is marked deleted */
#define SC_SUCCESS		0			/* successful function return code */
#define SC_WRTFAIL		-1		/* ERROR - file write failure */
#define SC_RDFAIL			-2		/* ERROR - file read failure */
#define SC_MEMERR			-3		/* ERROR - memory allocation error */
#define SC_BADFLD			-4		/* ERROR - bad user specified field description */
#define SC_NODBF			-5		/* ERROR - file not in .DBF format */
#define SC_SKFAIL			-6		/* ERROR - file pointer reposition failed */
#define SC_NOFILE			-7		/* ERROR - file not found */
#define SC_FILBAD			-8		/* ERROR - file corrupted */
#define SC_BADEXPR		-9		/* ERROR - bad user specified key expression */
#define SC_NONDX			-10		/* ERROR - file not in .NDX format */
#define SC_NOHNDL			-11		/* ERROR - no handles available */
#define SC_NOPGS			-12		/* ERROR - no index pages loaded */
#define SC_BADPG			-13		/* ERROR - index page was not loaded */
#define SC_CLOSFAIL		-14		/* ERROR - file close failure */
#define SC_BADCMD			-15		/* ERROR - invalid command */
#define SC_BADHNDL		-16		/* ERROR - invalid handle number */
#define SC_BADFNAME		-17		/* ERROR - invalid filename */
#define SC_BADOFS			-18		/* ERROR - invalid offset */
#define SC_BADCOORDS	-19		/* ERROR - bad window coordinates */
#define SC_WINOVRLAD	-20		/* ERROR - window is overlaid by another */
#define SC_2MANYWINS	-21		/* ERROR - too many open windows */
#define SC_BADDATE		-22		/* ERROR - invalid date */





/**********
 *
 *	Common SoftC Prototypes
 *
 **********/




signed short int scinit( signed char, signed char );
signed short int scterm( void );
signed char *scvers( void );




/**********
 *
 *	Clock / Calendar Definitions
 *
 **********/




/* sccdxlat */
#define SC_2DBASE 1					/* convert from "mm/dd/[yy]yy" to "yyyymmdd" */
#define SC_2ASCII	8					/* convert from "yyyymmdd" to "mm/dd/yy" */
#define SC_2ASCIIL 10				/* convert from "yyyymmdd" to "mm/dd/yyyy" */




/**********
 *
 *  Clock / Calendar Prototypes
 *
 **********/




signed short int sccday( signed char, signed char * );
signed short int sccddiff( signed char *, signed char *, signed long * );
signed short int sccdn2s( signed int, signed int, signed int, signed char * );
signed short int sccds2n( signed char *, signed int *, signed int *,
		signed int* );
signed char sccdvalid( signed char * );
signed short int sccdxlat( signed char, signed char *, signed char * );
signed char sccleap( signed char * );
signed char sccleapi( signed int );
signed short int sccmonth( signed char, signed char * );




/**********
 *
 *	Error Handling Prototypes
 *
 **********/




void sceclr( void );
signed char *scemsg( void );
